/*
Copyright 1999 - CPL (Computational Perception Lab)
This code is provided with NO SUPPORT by the (somewhat) friendly people 
in the Computational Perception Lab at the Georgia Institute of Technology. 
Send questions/comments for us to ignore to:
brostow@cc.gatech.edu or wasinee@cc.gatech.edu
*/

#ifndef glXDisplay_H
#define glXDisplay_H


#include <X11/X.h>		/* X */
#include <X11/Xlib.h>
#include <X11/Xutil.h>
#include <X11/keysym.h>
#include <Xm/MwmUtil.h>

#include <GL/glx.h>		/* OpenGL */
#include <GL/gl.h>

class glXDisplay {

  int             init_x;
  int             init_y;
  XVisualInfo     *vi;
  Display         *dpy;
  Window          window;
  GLXContext      ctx;
  
public:
  int             flip;
  int             xsize; 
  int		  ysize;
  int             ncanvas;
  int             frameXsize;

  glXDisplay(int flip = 0) {
    this->flip = flip;    
  }

  void CreateWindowAndContext(Window * win, GLXContext * ctx, int *visualAttr, char name[]);
  
  void setupWindow(int width, int height, int ncanvas=1);

  void drawPixels(unsigned char *data, int canvasid);
};

#endif // ifndef glXDisplay_H
