/*

Graphics command header file.

Greg Turk, April 1997

*/


typedef float gtMatrix[4][4];
typedef float gtVector[3];

typedef struct Texture {
  int xsize, ysize;
  unsigned char *data;
} Texture;
   

void gtInitialize();
void gtPushMatrix();
void gtPopMatrix();
void gtTranslate(float, float, float);
void gtScale(float, float, float);
void gtRotate(float, float, float, float);
void gtOrtho(float, float, float, float, float, float);
void gtPerspective(float, float, float, float);
void gtLookAt(float, float, float, float, float, float, float, float, float);
void copy_stack(gtMatrix);

void apply_current_matrix(gtVector);
void copy_vector(gtVector, gtVector);
float dot_product(gtVector, gtVector);
void normalize_vector(gtVector);
void vector_subtract(gtVector,gtVector,gtVector);

float mat_invert (gtMatrix);

void copy_matrix(gtMatrix, gtMatrix);
void transpose_matrix(gtMatrix);
void transform(gtVector,gtMatrix);
void transformvec(gtVector,gtMatrix);
void print_matrix(gtMatrix);


extern "C" {
Texture *load_texture(char *);
}
